package controllers

import (
	"github.com/gogf/gf/v2/net/ghttp"
	"yx-dataset-server/app/bll"
	"yx-dataset-server/app/errors"
	"yx-dataset-server/app/schema"
	"yx-dataset-server/library/gplus"
)

type ChatMessage struct {
	ChatMessageBll bll.IChatMessage
}

func NewChatMessage(bChatMessage bll.IChatMessage) *ChatMessage {
	return &ChatMessage{
		ChatMessageBll: bChatMessage,
	}
}

// Query 查询数据
func (a *ChatMessage) Query(r *ghttp.Request) {
	switch r.Get("q").String() {
	case "page":
		a.QueryPage(r)
	case "list":
		a.QueryList(r)
	default:
		gplus.ResError(r, errors.ErrUnknownQuery)
	}
}

// QueryPage 查询分页数据
// @Tags
// @Summary 查询分页数据
// @Param Authorization header string false "Bearer 用户令牌"
// @Param current query int true "分页索引" 1
// @Param pageSize query int true "分页大小" 10
// @Success 200 []schema.ChatMessage "查询结果：{list:列表数据,pagination:{current:页索引,pageSize:页大小,total:总数量}}"
// @Failure 400 schema.HTTPError "{error:{code:0,message:未知的查询类型}}"
// @Failure 401 schema.HTTPError "{error:{code:0,message:未授权}}"
// @Failure 500 schema.HTTPError "{error:{code:0,message:服务器错误}}"
// @Router GET /api/v1/chat_message?q=page
func (a *ChatMessage) QueryPage(r *ghttp.Request) {
	ctx := gplus.NewContext(r)
	var params schema.ChatMessageQueryParam
	params.SessionId = r.Get("session_id").String()
	result, err := a.ChatMessageBll.Query(ctx, params, schema.ChatMessageQueryOptions{
		PageParam: &schema.PaginationParam{
			PageIndex: gplus.GetPageIndex(r),
			PageSize:  gplus.GetPageSize(r),
		},
	})
	if err != nil {
		gplus.ResError(r, err)
	}
	gplus.ResPage(r, result.Data, result.PageResult)
}

// QueryList 查询列表数据
// @Tags
// @Summary 查询列表数据
// @Param Authorization header string false "Bearer 用户令牌"
// @Success 200 []schema.ChatMessage "查询结果：{list:列表数据}"
// @Failure 400 schema.HTTPError "{error:{code:0,message:未知的查询类型}}"
// @Failure 401 schema.HTTPError "{error:{code:0,message:未授权}}"
// @Failure 500 schema.HTTPError "{error:{code:0,message:服务器错误}}"
// @Router GET /api/v1/chat_message?q=list
func (a *ChatMessage) QueryList(r *ghttp.Request) {
	ctx := gplus.NewContext(r)
	var params schema.ChatMessageQueryParam
	params.SessionId = r.Get("session_id").String()
	result, err := a.ChatMessageBll.Query(ctx, params)
	if err != nil {
		gplus.ResError(r, err)
	}
	gplus.ResList(r, result.Data)
}

// Get 获取数据
// @Summary 获取数据
// @Param id path string true "记录ID"
// @Success 200  schema.ChatMessage
// @Failure 400  schema.HTTPError "{error:{code:0,message:无效的请求参数}}"
// @Failure 401  schema.HTTPError "{error:{code:0,message:未授权}}"
// @Failure 500  schema.HTTPError "{error:{code:0,message:服务器错误}}"
// @Router  /api/v1/chat_message/{id}
func (a *ChatMessage) Get(r *ghttp.Request) {
	ctx := gplus.NewContext(r)
	result, err := a.ChatMessageBll.Get(ctx, r.Get("id").String())
	if err != nil {
		gplus.ResError(r, err)
	}
	gplus.ResSuccess(r, result)
}

// Create 创建数据
// @Tags API-ChatMessage
// @Summary 创建数据
// @Param body schema.ChatMessage true "提交的数据"
// @Success 200  schema.ChatMessage
// @Failure 400  schema.HTTPError "{error:{code:0,message:无效的请求参数}}"
// @Failure 401  schema.HTTPError "{error:{code:0,message:未授权}}"
// @Failure 500  schema.HTTPError "{error:{code:0,message:服务器错误}}"
// @Router /api/v1/chat_messages/ [post]
func (a *ChatMessage) ChatMessage(r *ghttp.Request) {
	var data schema.ChatMessage
	if err := gplus.ParseJson(r, &data); err != nil {
		gplus.ResError(r, err)
	}

	ctx := gplus.NewContext(r)
	result, err := a.ChatMessageBll.ChatMessage(ctx, r, &data)
	if err != nil {
		gplus.ResError(r, err)
	}
	ResSuccess(r, result)
}

func (a *ChatMessage) StreamChatMessage(r *ghttp.Request) {
	var data schema.ChatMessage
	if err := gplus.ParseJson(r, &data); err != nil {
		gplus.ResError(r, err)
	}

	ctx := gplus.NewContext(r)
	a.ChatMessageBll.StreamChatMessage(ctx, r, data)
	ResSuccess(r, nil)
}

// Update 更新数据
// @Summary 更新数据
// @Param body schema.ChatMessage true "更新数据"
// @Success 200  schema.ChatMessage
// @Failure 400  schema.HTTPError "{error:{code:0,message:无效的请求参数}}"
// @Failure 401  schema.HTTPError "{error:{code:0,message:未授权}}"
// @Failure 500  schema.HTTPError "{error:{code:0,message:服务器错误}}"
// @Router  /api/v1/chat_message/{id}
func (a *ChatMessage) Update(r *ghttp.Request) {
	var data schema.ChatMessage
	if err := gplus.ParseJson(r, &data); err != nil {
		gplus.ResError(r, err)
	}
	ctx := gplus.NewContext(r)
	result, err := a.ChatMessageBll.Update(ctx, r.Get("id").String(), data)
	if err != nil {
		gplus.ResError(r, err)
	}
	gplus.ResSuccess(r, result)
}

// Delete 删除数据
// @Summary 删除数据
// @Param id path string true "记录ID"
// @Success 200  schema.HTTPStatus "{status:OK}"
// @Failure 400  schema.HTTPError "{error:{code:0,message:无效的请求参数}}"
// @Failure 401  schema.HTTPError "{error:{code:0,message:未授权}}"
// @Failure 500  schema.HTTPError "{error:{code:0,message:服务器错误}}"
// @Router  /api/v1/chat_message/{id}
func (a *ChatMessage) Delete(r *ghttp.Request) {
	ctx := gplus.NewContext(r)
	err := a.ChatMessageBll.Delete(ctx, r.Get("id").String())
	if err != nil {
		gplus.ResError(r, err)
	}
	gplus.ResOK(r)
}
